package Bankkonto;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Definition der Methoden fr unser Bankkonto
 * abfragen des Kontostandes
 * einzahlen eines bestimmten Betrages
 * abheben eines bestimmten Betrages
 */

public interface Konto
    extends Remote
{
    /**
     * abfragen des Kontostandes : liefert als float den Kontostand
     */
    public abstract float kontostand()
        throws RemoteException;

    /**
     * einzahlen eines (float) Betrages f auf das Konto
     */
    public abstract void einzahlen(float f)
        throws ungltigerBetragException, RemoteException;

    /**
     * abheben eines (float) Betrages f vom Konto
     */
    public abstract void abheben(float f)
        throws ungltigerBetragException, RemoteException;
}
