// KontoImpl - Implementation des Konto Interfaces
//
// Instanzen dieser Klasse implementieren die Methoden:
// kontostand, abheben, einzahlen
// welche im Interface Konto definiert wurden
package Bankkonto;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class KontoImpl extends UnicastRemoteObject implements Konto {
	// aktueller Kontostand
	private float kontostand = 0;
	// neues Konto erffnen : Konstruktor
	public KontoImpl(float neuerKontostand) throws RemoteException {
		System.out.println("KontoImpl: Konstruktor");
		kontostand = neuerKontostand;
	}
	// Methoden
	// Kontostand abfragen
	public float kontostand() throws RemoteException {
		System.out.println("KontoImpl.kontostand(): Kontostand abfragen; Kontostand ="+kontostand);
		return kontostand;
	}
	// Betrag einbezahlen, sofern Betrag positiv
	public void einzahlen(float betrag) throws ungltigerBetragException, RemoteException {
		System.out.println("KontoImpl.einzahlen(): Betrag einzahlen;");
		System.out.println("KontoImpl: Kontostand alt: "+kontostand);
		if (betrag<0) {
			throw new ungltigerBetragException("Fehler : Versuch einen negativen Betrag einzubezahlen!");
		} else {
			kontostand = kontostand + betrag;
		}
		System.out.println("KontoImpl.einzahlen(): Kontostand neu: "+kontostand);
	}
	// Betrag abheben, falls das Konto darber verfgt
	public void abheben(float betrag) throws ungltigerBetragException, RemoteException {
		System.out.println("KontoImpl.abheben(): Betrag abheben; Betrag ="+betrag+" Kontostand alt: "+kontostand);
		System.out.println("KontoImpl.abheben(): Kontostand alt: "+kontostand);
		if (betrag < 0) {
			throw new ungltigerBetragException("KontoImpl.abheben() Fehler : Versuch einen negativen Betrag abzuheben!");
		} else {
			if ((kontostand - betrag)<0) {
				throw new ungltigerBetragException("KontoImpl.abheben() Fehler : Versuch Konto zu berziehen!");
			} else {
				kontostand = kontostand - betrag;
			}
		}
		System.out.println("KontoImpl.abheben(): Kontostand neu: "+kontostand);
	}
}
