package Bankkonto;

/**
 * Der Kontomanager kreiert (im Auftrag, als Objekt Factory) ein
 * neues Konto fr einen Kunden
 * Parameter: Kundenname und Startbetrag.
 */
import java.io.PrintStream;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Vector;

public class KontoManagerImpl extends UnicastRemoteObject
    implements KontoManager
{

    private static Vector konten = new Vector();

    public KontoManagerImpl()
        throws RemoteException
    {
	System.out.println("KontoManager: Konstruktor");
    }

    public Konto erffnen(String name, float startKapital)
        throws RemoteException, ungltigerBetragException
    {
	System.out.println("KontoManager.erffnen(): Startkapital= "+startKapital);
        	KontoInfo a;
        	for(int i = 0; i < konten.size(); i++) {
            	a = (KontoInfo)konten.elementAt(i);
            	if(a.name.equals(name))
                	return a.konto;
        	}
        	if(startKapital < (float)0)
            	throw new ungltigerBetragException("Fehler : negativer Startbetrag!");
        	a = new KontoInfo();
        	try {
            	a.konto = new KontoImpl(startKapital);
        	}
        	catch(RemoteException e) {
            	System.err.println("Fehler : neues Konto konnte nicht kreiert werden!");
            	System.err.println(" " + e.getMessage());
            	throw e;
        	}
        	a.name = name;
        	konten.addElement(a);
        	return a.konto;
    }
}
