// BankClient - Test Programm fr unser RMI Bankkonto Beispiel
//
// Diese Klasse sucht ein "KontoManager" RMI Objekt,
// bindet dieses und ffnet eine KontoManager Instanz
// auf dem Server
//
// Dann legt es ein Konto mit demNamen <name> und einem oder
// keinem Startkapital an
//
// Das Konto wird dann getestet, indem einfach Betrge einbezahlt
// und abgehoben werden, sowie der Kontostand abgefragt wird.
//
package Bankkunde;

import java.rmi.*;
// Interfaces importieren
import Bankkonto.*;

public class Kunde {
	public static void main(String args[] ) {
		// Argumente prfen
		if (args.length < 2) {
			System.err.println("Usage : ");
			System.err.println("java Bankkunde <server> <Kontonamen> [Startkapital]");
			System.exit(1);
		}

		// kreieren und installieren des SecurityManagers
		System.setSecurityManager(new RMISecurityManager() );

		// Kontomanager suchen
		try {
			System.out.println("Kunde.main() ; lookup KontoManager");
			String url = new String("rmi://"+args[0]+"/KontoManager");
			KontoManager ktm = (KontoManager)Naming.lookup(url);
			// Initialisieren des Bankkontos
			float startBetrag = 0.0f;
			// ... falls ein Betrag angegeben wurde
			if (args.length ==3) {
				Float F = Float.valueOf(args[2]);
				startBetrag = F.floatValue();
			}

			// ... und nun das Konto anlegen oder nachsehen
			Konto konto = ktm.erffnen(args[1], startBetrag);

			// Jetzt spielen wir mit dem Konto
			System.out.println("Kunde.main() : aktueller Kontostand = "+konto.kontostand() );

			System.out.println("Kunde.main() : 50.00 abheben");
			konto.abheben(50.00f);

			System.out.println("Kunde.main() : aktueller Kontostand = "+konto.kontostand() );

			System.out.println("Kunde.main() : 100.00 einzahlen");
			konto.einzahlen(100.00f);

			System.out.println("Kunde.main() : aktueller Kontostand = "+konto.kontostand() );

			System.out.println("Kunde.main() : 25.00 einzahlen");
			konto.einzahlen(25.00f);

			System.out.println("Kunde.main() : aktueller Kontostand = "+konto.kontostand() );
		} catch (Exception e) {
			System.err.println("Kunde : eine Ausnahme wurde geworfen; "+e.getMessage());
			e.printStackTrace();
		}
		System.exit(1);
	}
}