package Client;

import java.rmi.*;
import java.math.*;
import berechne.*;

public class BerechnePi {
    public static void main(String args[]) {
        // Security Manager
        System.out.println("BerechnePi: SecurityManager");
        if (System.getSecurityManager() == null) {
           System.setSecurityManager(new RMISecurityManager());
        }
        try {
	// remote Host : Host auf der die Registry luft
            String name = "rmi://" + args[0] + "/Berechne";
	// suchen der remote Referenz in der Registry
            System.out.println("BerechnePi: Naming.lookup("+name+")");
            Berechne berech = (Berechne) Naming.lookup(name);

	// Genauigkeit der Berechnung : args[1]; 
	System.out.println("BerechnePi: Instanzieren von Pi");
            Pi aufgabe = new Pi(Integer.parseInt(args[1]));
            BigDecimal pi = (BigDecimal) (berech.ausfhrenDerAufgabe(aufgabe));
            System.out.println(pi);
        } catch (Exception e) {
            System.err.println("BerechnePi Exception: " + e.getMessage());
            e.printStackTrace();
        }
    }    
}
