package derserver;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.rmi.*;
import dasinterface.DieKlasse;

public class DerServer {
  public static void main(String[] args) {
    System.out.println("[DerServer]Start");
    try {
      System.out.println("[DerServer]Kreieren eines (remote/Server-) Objekts");
      DieKlasse einObjekt = new DieKlasse();

      System.out.println("[DerServer]Abfrage der Registry");

      // binden der Instanz an die Registry
      System.out.println("[DerServer]binden des Objekts an die Registry");

      // zum Testen : Abfrage der Registry
      System.out.println("[DerServer]registrierte Objekte vor dem Binden");
      for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
      	System.out.println(" "+Naming.list("rmi://localhost/")[i]);

      // rebind() ist besser als bind() :
      // falls das Objekt gebunden ist, wird es einfach neu gebunden
      // falls das Objekt nicht gebunden ist, wird es gebunden (wie bind() )
      Naming.rebind("MeinObjekt",einObjekt);
      // zum Testen : Abfrage der Registry
      System.out.println("[DerServer]registrierte Objekte nach dem Binden");
      for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
      	System.out.println(" "+Naming.list("rmi://localhost/")[i]);

      System.out.println("[DerServer]Das Objekt wurde gebunden (in die Registry eingetragen)!");
    } catch (Exception e) {
      System.err.println("DerServer]Eine Ausnahme wurde geworfen - "+e.getMessage() );
      e.printStackTrace();
    }
    System.out.println("[DerServer] ... und Tschuess!");
  }
}
