package einfuehrendesbeispiel;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.rmi.*;
public class DerClient {
  public static void main(String[] args) {
    // kreieren und installieren des SecurityManagers
    // sonst hat der Client keinen Zugriff ...
    //System.setSecurityManager(new RMISecurityManager() );

    // 'meinObjekt' in der Registry suchen (Eintrag in der Registry als String)
    try {
      System.out.println("[DerClient]Start");
      String url = new String("rmi://localhost/MeinObjekt");

      // zum Testen : Abfrage der Registry
      System.out.println("[DerClient]registrierte Objekte in der Registry");
      for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
      	System.out.println(" "+Naming.list("rmi://localhost/")[i]);

      System.out.println("[DerClient]Objektcasting");

      // hier muss das Interface stehen, das Objekt ist nicht bekannt!
      DasInterface meinRemoteObjekt = (DasInterface)Naming.lookup(url);
      System.out.println("[DerClient]Aufruf der remote Methode wieGehts() - "+meinRemoteObjekt.wieGehts());
    } catch (Exception e) {
      System.err.println("[DerClient]eine Ausnahme wurde geworfen; "+e.getMessage());
      e.printStackTrace();
    }
  }
}